package com.reactlibrary;

import android.app.Activity;
import android.content.Context;
import android.graphics.Color;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.RelativeLayout;

import androidx.annotation.NonNull;

import com.appodeal.ads.Appodeal;
import com.appodeal.ads.NativeAd;
import com.appodeal.ads.native_ad.views.NativeAdViewAppWall;
import com.appodeal.ads.native_ad.views.NativeAdViewContentStream;
import com.appodeal.ads.native_ad.views.NativeAdViewNewsFeed;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.common.MapBuilder;
import com.facebook.react.uimanager.SimpleViewManager;
import com.facebook.react.uimanager.ThemedReactContext;
import com.facebook.react.uimanager.ViewGroupManager;
import com.facebook.react.uimanager.annotations.ReactProp;
import com.facebook.react.views.view.ReactViewGroup;

import java.util.Map;

import javax.annotation.Nullable;

public class NativeAdViewManager extends ViewGroupManager<NativeAdWrapper> {

    public static final String REACT_CLASS = "RNNativeAdView";
    private NativeAdWrapper nativeAdView;
    private ThemedReactContext reactContext;

    @NonNull
    @Override
    public String getName() {
        return REACT_CLASS;
    }

    @NonNull
    @Override
    protected NativeAdWrapper createViewInstance(@NonNull ThemedReactContext themedReactContext) {
        nativeAdView = new NativeAdWrapper(themedReactContext);
        return nativeAdView;
    }

    @Override
    public void addView(NativeAdWrapper parent, View child, int index) {
        //parent.addView(child, index);
    }

    @ReactProp(name = "type")
    public void setType(NativeAdWrapper view, int type) {
        view.setNativeAdType(type);
    }

    @ReactProp(name = "show")
    public void setShow(NativeAdWrapper view, int type) {
        view.setShow(type);
    }
}
