package com.reactlibrary;

import android.content.Context;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;

import androidx.annotation.NonNull;

import com.appodeal.ads.Appodeal;
import com.appodeal.ads.NativeAd;
import com.appodeal.ads.native_ad.views.NativeAdViewNewsFeed;
import com.facebook.react.uimanager.SimpleViewManager;
import com.facebook.react.uimanager.ThemedReactContext;
import com.facebook.react.uimanager.annotations.ReactProp;

import java.util.List;

public class NativeAdViewNewsFeedManager extends SimpleViewManager<NativeAdViewNewsFeed>  {

    public static final String REACT_CLASS = "RNNativeAdViewFeedNews";
    NativeAdViewNewsFeed nativeAdViewNewsFeed;
    NativeAd nativeAd;
    int nativeAdIndex = 0;

    @NonNull
    @Override
    public String getName() {
        return REACT_CLASS;
    }

    @NonNull
    @Override
    protected NativeAdViewNewsFeed createViewInstance(@NonNull ThemedReactContext themedReactContext) {
        LayoutInflater inflater = (LayoutInflater) themedReactContext.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
        nativeAdViewNewsFeed = (NativeAdViewNewsFeed) inflater.inflate(R.layout.native_ad_view_news_feed, null);
        return nativeAdViewNewsFeed;
    }

    @ReactProp(name = "index", defaultInt = 0)
    public void setIndex(NativeAdViewNewsFeed view, int index) {
        nativeAdIndex = index;
    }

    @ReactProp(name = "isLoaded", defaultBoolean = false)
    public void setIsLoaded(NativeAdViewNewsFeed view, Boolean isLoaded) {
        if (isLoaded) {
            int count = Appodeal.getAvailableNativeAdsCount();
            Log.v("asd", Integer.toString(count));
            Log.v("asd index", Integer.toString(nativeAdIndex));
            if (count > 0) {
                List<NativeAd> list = Appodeal.getNativeAds(1);
                nativeAd = list.get(count > nativeAdIndex ? nativeAdIndex : 0);
                view.setNativeAd(nativeAd);
                view.post(measureAndLayout);
            }
        } else {
            if (nativeAd != null) nativeAd.destroy();
            view.post(measureAndLayout);
        }
    }

    private final Runnable measureAndLayout = new Runnable() {
        @Override
        public void run() {
            nativeAdViewNewsFeed.measure(
                    View.MeasureSpec.makeMeasureSpec(nativeAdViewNewsFeed.getWidth(), View.MeasureSpec.EXACTLY),
                    View.MeasureSpec.makeMeasureSpec(nativeAdViewNewsFeed.getHeight(), View.MeasureSpec.EXACTLY));
            nativeAdViewNewsFeed.layout(nativeAdViewNewsFeed.getLeft(), nativeAdViewNewsFeed.getTop(), nativeAdViewNewsFeed.getRight(), nativeAdViewNewsFeed.getBottom());
        }
    };
}
